% Created 2018-12-11 Di 03:38
\documentclass[11pt]{article}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{fixltx2e}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{float}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{marvosym}
\usepackage{wasysym}
\usepackage{amssymb}
\usepackage{hyperref}
\tolerance=1000
\author{Thejeswi Preetham Nagendra Kamatchi}
\date{\today}
\title{Using First Order Logic for performing judgment prediction on a corpus of legal text}
\hypersetup{
  pdfkeywords={},
  pdfsubject={},
  pdfcreator={Emacs 25.2.2 (Org mode 8.2.10)}}
\begin{document}

\maketitle
\section{Goal}
\label{sec-1}
To \emph{algoritmize} legal code text, such that provided descriptions of circumstances yield relavent legal concequence.

By \emph{algorithmize} I specifically mean, to create a first order logic representation of legal text which is input to our system. Possibly, the system can be generalized for any form of text in the future.

\section{Status of completed work}
\label{sec-2}
The modules which have been completed in the pipeline are:
\begin{itemize}
\item Legal text download and segmentation 
(Scripts have been written to do this; no manual work required, if working with the German legal code)
\item Feature generation of text:
\begin{itemize}
\item WordNet: For finding Synonyms and Hypernyms.
\item Stanford CoreNLP: For dependency parse trees, used for finding Unary and Binary predicates.
\item FastText: Similar words to each non stopword in the legal text
\end{itemize}
\item Case to Legal text matcher: 
\begin{itemize}
\item Legal case description input in the form of few sentences in concise language.
\item The case text is segmented to find the actor/actors, action and the circumstance.
\item Text search along with our algorithm is used to find relavent text.
\end{itemize}
\item Judgment prediction demonstration prototype.
\end{itemize}
\section{Judgement prediction algorithm:}
\label{sec-3}
Once the relevant legal text is found, the First Order Logic (\emph{FOL}) fun begins!
\begin{itemize}
\item First find text segment with the target \emph{term}. In simple legal text, this maybe a specific judgment; such as a jail term or a fine.
\item Next find all the \emph{function words} with simple regular expressions. These provide the necessary operations for the \emph{FOL} statements. The various \emph{terms} of the \emph{FOL} statements, would be computed using these \emph{function words}.
\end{itemize}
\begin{center}
\begin{tabular}{ll}
\hline
Function word & \emph{FOL} meaning\\
\hline
and & conjunction ($\wedge$)\\
or & disjunction ($\lor$)\\
shall & implication (\implies)\\
not & negation    (\lnot)\\
\hline
\end{tabular}
\end{center}

\begin{itemize}
\item Find the Unary and Binary predicates in the legal text. We use the \emph{dependency parse tree} obtained from \texttt{CoreNLP}, along with list of manually defined rules for the parse trees to detect these.
\item Each of the predicates are considered as a term; a block of sucessive predicates are concatenated with an \emph{AND} operation.
\item From case text input, the circumstance and the act is extracted. The circumstance and the act is matched with the predicates in the legal text.
\item A match results in the \emph{term} or \emph{variable} to be set to \emph{True}. No match results in a \emph{False} assignment to the term.
\item If consecutive predicates are mostly \emph{True} (>80\%), the whole block of \emph{terms} are assigned to \emph{True}. (Most often there will be no perfect match between the text of the client and the legal language. Consequently this ``leap of assumption'' makes the system slightly ``bullish'' with judgements.
\item The terms are evaluated with their values along with the functions to obtain a final binary value. This tells us if the target term is satisfied or not.
\end{itemize}

\section{Evaluation of current work (specific to the Judger)}
\label{sec-4}
\begin{itemize}
\item Currently works well only for a subset of the StGB, or other similar legal text.
\item The system is fragile; Breaks often for sentence structures not designed for.
\item Measuring the accuracy of the results turns out to be expensive. While, simple cases are trivial to verify, many cases are not trivial.
\item The discrete binary nature of the system causes a ``hit or miss'' behavior.
\end{itemize}

\section{Improvements to be made}
\label{sec-5}
\begin{itemize}
\item The ``hit or miss'' problem can be fixed by extending the \emph{FOL} system with Markov networks. The terms can be provided a probability value, rather than a discrete/binary value. Therefore the final result can be presented with a probability / confidence score. Thus the misses can be avoided, rather some judgment can be show, however with lower score.

\item Lawyers should perform fact discovery and collection when tasked with a case to work on. The lawyer needs to find all the relevant facts pertaining to the case, from either the client or other suitable sources. Similarly, once a preliminary legal text search is completed, our system will need to find all the unsatisfied/unmatched predicates and query the user.

\item While legal links feature works independently, it has not be integrated to the matcher/jugder.
\end{itemize}

\begin{itemize}
\item Parenthesis used for grouping terms, thereby changing the order of evaluation is vital for this idea to work on any non-trivial legal text. This feature has not yet been implemented.

\item Implies \emph{FOL} operation (\emph{shall} function word) has not been implemented. Although implications are assumed between an action (or it's negation) and an judgement. This may not be true in all situations.

\item System fails for tables/figures.

\item Enumeration is a major roadblock. Most legal text are enumerated. Current strategies of ``stitching'' enumerated text to a cohesive statement don't work well enough to produce good parse trees. Parse trees are a basic requirement for the judgement prediction system.

\item WordNet definition graphs (Vivian's work) with justification and word expansion can improve the matcher system.

\item Semantic matching is performed only at the word level. In many scenarios, complete phrases maybe need to be matched to individual words. Using phrases from a word's definition to match a word could help to an extent.
\end{itemize}
% Emacs 25.2.2 (Org mode 8.2.10)
\end{document}
